package com.liang.service;

import com.liang.entity.PrjProject;
import com.liang.entity.StaBudgetapproval;
import com.liang.entity.StaReimbursement;
import com.liang.vo.dto.StaReimbursementVo;
import com.liang.vo.dto.ViewFileVo;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * 报账(StaReimbursement)表服务接口
 *
 * @author makejava
 * @since 2023-05-16 13:06:38
 */
public interface StaReimbursementService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaReimbursement queryById(Integer id);

    /**
     * FYSQ
     *
     * @param fysq
     * @return
     */
    StaReimbursement queryByFYSQ(Integer fysq);

    /**
     * 分页查询
     *
     * @param staReimbursement 筛选条件
     * @param pageRequest      分页对象
     * @return 查询结果
     */
    Page<StaReimbursement> queryByPage(StaReimbursement staReimbursement, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param staReimbursement 实例对象
     * @return 实例对象
     */
    int insert(StaReimbursement staReimbursement);

    /**
     * 修改数据
     *
     * @param staReimbursement 实例对象
     * @return 实例对象
     */
    int update(StaReimbursement staReimbursement);

    /**
     * 撤销数据（基本信息）
     *
     * @param staReimbursement 实例对象
     * @return 影响行数
     */
    int tjrevokeApprove(StaReimbursement staReimbursement);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 获取报账列表
     *
     * @return
     */
    List<StaReimbursement> getReimburseList(Map map);

    /**
     * 批量删除报账
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 修改审批状态
     *
     * @param staReimbursement 实例对象
     * @return 实例对象
     */
    int updateSpzt(StaReimbursement staReimbursement);

    /**
     * 老板修改报账
     *
     * @param staReimbursement 实例对象
     * @return 影响行数
     */
    int updateBZJE(StaReimbursement staReimbursement);

    List<ViewFileVo> viewFile(Integer bzId);

    int tjrevokeApprove1(StaReimbursement bzrxm);
}
